/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.web.gui.controladores.relatorios;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.sql.DataSource;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Controller;
import org.zkoss.util.resource.Labels;
import org.zkoss.zhtml.Messagebox;
import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zul.Bandbox;
import org.zkoss.zul.Checkbox;
import org.zkoss.zul.Combobox;
import org.zkoss.zul.Comboitem;
import org.zkoss.zul.Datebox;
import org.zkoss.zul.Paging;
import org.zkoss.zul.Radio;
import org.zkoss.zul.Textbox;

import com.rjconsultores.ventaboletos.entidad.Empresa;
import com.rjconsultores.ventaboletos.entidad.Estado;
import com.rjconsultores.ventaboletos.entidad.PuntoVenta;
import com.rjconsultores.ventaboletos.entidad.TipoPuntoVenta;
import com.rjconsultores.ventaboletos.relatorios.impl.RelatorioReceitaDiariaAgencia;
import com.rjconsultores.ventaboletos.relatorios.utilitarios.Relatorio;
import com.rjconsultores.ventaboletos.service.EmpresaService;
import com.rjconsultores.ventaboletos.service.EstadoService;
import com.rjconsultores.ventaboletos.service.PuntoVentaService;
import com.rjconsultores.ventaboletos.service.TipoPuntoVentaService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;
import com.rjconsultores.ventaboletos.web.utilerias.MyGenericForwardComposer;
import com.rjconsultores.ventaboletos.web.utilerias.MyListbox;
import com.rjconsultores.ventaboletos.web.utilerias.paginacion.HibernateSearchObject;
import com.rjconsultores.ventaboletos.web.utilerias.paginacion.PagedListWrapper;
import com.rjconsultores.ventaboletos.web.utilerias.render.RenderEstadoSimple;
import com.rjconsultores.ventaboletos.web.utilerias.render.RenderPuntoVentaSimple;
import com.trg.search.Filter;

/**
 * 
 * @author Administrador
 */
@Controller("relatorioReceitaDiariaAgenciaController")
@Scope("prototype")
public class RelatorioReceitaDiariaAgenciaController extends MyGenericForwardComposer {

	private static final long serialVersionUID = 1L;
	@Autowired
	private EstadoService estadoService;
	@Autowired
	private EmpresaService empresaService;
	@Autowired
	private PuntoVentaService puntoVentaService;
	@Autowired
	private TipoPuntoVentaService tipoPuntoVentaService;
	@Autowired
	private DataSource dataSourceRead;

	private List<Estado> lsEstado;
	private List<Empresa> lsEmpresa;
	private List<TipoPuntoVenta> lsTipoPuntoVenta;

	private List<PuntoVenta> lsNumPuntoVenta;

	@Autowired
	private transient PagedListWrapper<PuntoVenta> plwPuntoVenta;

	private MyListbox puntoVentaList;
	private MyListbox estadoList;
	private MyListbox puntoVentaSelList;
	private Paging pagingPuntoVenta;

	private Bandbox bbPesquisaPuntoVenta;

	private Textbox txtPalavraPesquisa;
	private Combobox cmbEstado;
	private Combobox cmbEmpresa;
	private Combobox cmbPuntoVenta;
	private Combobox cmbTipoPuntoVenta;
	private Combobox cmbReceitaImposto;
	private Datebox datInicial;
	private Datebox datFinal;
	private Checkbox chkExcessoBagagem;
	private Checkbox chkContemplarGap;
	private Radio rd1;

	public Datebox getDatInicial() {
		return datInicial;
	}

	public void setDatInicial(Datebox datInicial) {
		this.datInicial = datInicial;
	}

	public Datebox getDatFinal() {
		return datFinal;
	}

	public void setDatFinal(Datebox datFinal) {
		this.datFinal = datFinal;
	}

	public List<Estado> getLsEstado() {
		return lsEstado;
	}

	public void setLsEstado(List<Estado> lsEstado) {
		this.lsEstado = lsEstado;
	}

	public Combobox getCmbEstado() {
		return cmbEstado;
	}

	public void setCmbEstado(Combobox cmbEstado) {
		this.cmbEstado = cmbEstado;
	}

	public Combobox getCmbPuntoVenta() {
		return cmbPuntoVenta;
	}

	public void setCmbPuntoVenta(Combobox cmbPuntoVenta) {
		this.cmbPuntoVenta = cmbPuntoVenta;
	}

	public MyListbox getPuntoVentaList() {
		return puntoVentaList;
	}

	public void setPuntoVentaList(MyListbox puntoVentaList) {
		this.puntoVentaList = puntoVentaList;
	}

	public Paging getPagingPuntoVenta() {
		return pagingPuntoVenta;
	}

	public void setPagingPuntoVenta(Paging pagingPuntoVenta) {
		this.pagingPuntoVenta = pagingPuntoVenta;
	}

	public Textbox getTxtPalavraPesquisa() {
		return txtPalavraPesquisa;
	}

	public void setTxtPalavraPesquisa(Textbox txtPalavraPesquisa) {
		this.txtPalavraPesquisa = txtPalavraPesquisa;
	}

	public Bandbox getBbPesquisaPuntoVenta() {
		return bbPesquisaPuntoVenta;
	}

	public void setBbPesquisaPuntoVenta(Bandbox bbPesquisaPuntoVenta) {
		this.bbPesquisaPuntoVenta = bbPesquisaPuntoVenta;
	}

	public Checkbox getChkExcessoBagagem() {
		return chkExcessoBagagem;
	}

	public void setChkExcessoBagagem(Checkbox chkExcessoBagagem) {
		this.chkExcessoBagagem = chkExcessoBagagem;
	}

	public MyListbox getPuntoVentaSelList() {
		return puntoVentaSelList;
	}

	public void setPuntoVentaSelList(MyListbox puntoVentaSelList) {
		this.puntoVentaSelList = puntoVentaSelList;
	}

	public List<Empresa> getLsEmpresa() {
		return lsEmpresa;
	}

	public void setLsEmpresa(List<Empresa> lsEmpresa) {
		this.lsEmpresa = lsEmpresa;
	}

	public List<TipoPuntoVenta> getLsTipoPuntoVenta() {
		return lsTipoPuntoVenta;
	}

	public void setLsTipoPuntoVenta(List<TipoPuntoVenta> lsTipoPuntoVenta) {
		this.lsTipoPuntoVenta = lsTipoPuntoVenta;
	}

	public void onClick$btnExecutarRelatorio(Event ev) throws Exception {
		executarRelatorio();
	}

	public void onDoubleClick$puntoVentaList(Event ev) {

		PuntoVenta puntoVentaSel = (PuntoVenta) puntoVentaList.getSelected();
		puntoVentaSelList.addItemNovo(puntoVentaSel);

	}

	public void onDoubleClick$puntoVentaSelList(Event ev) {

		PuntoVenta puntoVentaSel = (PuntoVenta) puntoVentaSelList.getSelected();
		puntoVentaSelList.removeItem(puntoVentaSel);

	}

	public void onSelect$puntoVentaList(Event ev) {

	}

	public void onClick$btnLimpar(Event ev) {
		limparPesquisaAgencia();
	}

	public void onClick$btnPesquisa(Event ev) {
		executarPesquisa();
	}

	/**
	 * 
	 */
	private void limparPesquisaAgencia() {
		puntoVentaSelList.setData(new ArrayList<Object>());

	}

	/**
	 * 
	 */
	private void executarPesquisa() {
		HibernateSearchObject<PuntoVenta> puntoVentaBusqueda =
				new HibernateSearchObject<PuntoVenta>(PuntoVenta.class,
						pagingPuntoVenta.getPageSize());

		puntoVentaBusqueda.addFilterOr(Filter.like("nombpuntoventa", "%" + txtPalavraPesquisa.getText().trim().toUpperCase().concat("%")), Filter.like("numPuntoVenta", "%" + txtPalavraPesquisa.getText().trim().toUpperCase().concat("%")));

		puntoVentaBusqueda.addSortAsc("nombpuntoventa");

		puntoVentaBusqueda.addFilterEqual("activo", Boolean.TRUE);

		plwPuntoVenta.init(puntoVentaBusqueda, puntoVentaList, pagingPuntoVenta);

		if (puntoVentaList.getData().length == 0) {
			try {
				Messagebox.show(Labels.getLabel("MSG.ningunRegistro"),
						Labels.getLabel("relatorioReceitaDiariaAgenciaController.window.title"),
						Messagebox.OK, Messagebox.INFORMATION);
			} catch (InterruptedException ex) {
			}
		}
	}

	/**
	 * @throws Exception
	 * 
	 */
	private void executarRelatorio() throws Exception {

		Map<String, Object> parametros = new HashMap<String, Object>();
		StringBuilder filtro = new StringBuilder();

		parametros.put("DATA_INICIO", new java.sql.Date(((java.util.Date) this.datInicial.getValue()).getTime()));
		parametros.put("DATA_FINAL", new java.sql.Date(((java.util.Date) this.datFinal.getValue()).getTime()));
		parametros.put("B_EXCLUI_BAGAGEM", chkExcessoBagagem.isChecked());
		parametros.put("B_CONTEMPLAR_GAP", chkContemplarGap.isChecked());
		parametros.put("NOME_RELATORIO", Labels.getLabel("relatorioReceitaDiariaAgenciaController.window.title"));
		parametros.put("ISDEVOLUCAODESTINO", rd1.isChecked() ? 0 : 1);
		parametros.put("USUARIO", UsuarioLogado.getUsuarioLogado().getUsuarioId().toString());

		parametros.put("BASE_CALCULO_IMPOSTO", Integer.valueOf(cmbReceitaImposto.getSelectedItem().getValue().toString()));

		lsNumPuntoVenta = new ArrayList(Arrays.asList(puntoVentaSelList.getData()));

		filtro.append("Agência(s): ");
		if (lsNumPuntoVenta.size() > 0) {
			parametros.put("NUMPUNTOVENTA", lsNumPuntoVenta);
			parametros.put("ISNUMPUNTOVENTATODOS", "N");
			filtro.append(lsNumPuntoVenta.size() + " selecionada(s);");
		}
		else {
			parametros.put("ISNUMPUNTOVENTATODOS", "S");
			filtro.append("Todas ;");
		}

		filtro.append("Estados(s): ");
		if (estadoList.getSelectedsItens().size() > 0) {
			parametros.put("ESTADO_ID", estadoList.getSelectedsItens());
			filtro.append(estadoList.getSelectedsItens().size() + " selecionado(s);");
		}
		else {
			filtro.append("Todos ;");
		}

		Comboitem itemEmpresa = cmbEmpresa.getSelectedItem();
		if (itemEmpresa != null) {
			Empresa empresa = (Empresa) itemEmpresa.getValue();
			parametros.put("EMPRESA_ID", empresa.getEmpresaId());
			parametros.put("EMPRESA_NOME", empresa.getNombempresa());
		}

		filtro.append(" Tipo Agência: ");
		Comboitem itemTipoPunto = cmbTipoPuntoVenta.getSelectedItem();
		if (itemTipoPunto != null && ((TipoPuntoVenta) cmbTipoPuntoVenta.getSelectedItem().getValue()).getTipoptovtaId() != -1) {
			TipoPuntoVenta tipoPuntoVenta = (TipoPuntoVenta) itemTipoPunto.getValue();
			parametros.put("TIPOPTOVTA_ID", tipoPuntoVenta.getTipoptovtaId().intValue());
			filtro.append(tipoPuntoVenta.getDesctipo() + ";");
		}
		else
			filtro.append("Todos;");

		if (chkContemplarGap.isChecked())
			filtro.append(" Contemplar GAP;");
		else
			filtro.append(" Desconsiderar GAP;");

		if (chkExcessoBagagem.isChecked())
			filtro.append(" Exclui Excesso de Bagagem;");
		else
			filtro.append(" Inclui Excesso de Bagagem;");

		filtro.append(" Devolução na agência: ");

		if (rd1.isChecked())
			filtro.append("Origem;");
		else
			filtro.append("Destino;");

		parametros.put("FILTROS", filtro.toString());

		Relatorio relatorio = new RelatorioReceitaDiariaAgencia(parametros, dataSourceRead.getConnection());

		Map args = new HashMap();
		args.put("relatorio", relatorio);

		openWindow("/component/reportView.zul",
				Labels.getLabel("relatorioReceitaDiariaAgenciaController.window.title"), args, MODAL);

	}

	@Override
	public void doAfterCompose(Component comp) throws Exception {
		lsEstado = estadoService.obtenerTodos();
		lsEmpresa = empresaService.obtenerTodos();
		setLsTipoPuntoVenta(tipoPuntoVentaService.obtenerTodos());
		super.doAfterCompose(comp);

		estadoList.setItemRenderer(new RenderEstadoSimple());
		puntoVentaList.setItemRenderer(new RenderPuntoVentaSimple());
		puntoVentaSelList.setItemRenderer(new RenderPuntoVentaSimple());

		estadoList.setData(lsEstado);
	}

}
